#pragma once

// STD/STL
#include <chrono>

// Eigen
#include <Eigen/Geometry>

// Simox
#include <VirtualRobot/Robot.h>

// Navigation
#include <armarx/navigation/core/types.h>
#include <armarx/navigation/server/execution/ExecutorInterface.h>

namespace armarx::navigation::server
{

    class DummyExecutor : virtual public ExecutorInterface
    {

    public:
        struct Params
        {
        };

        DummyExecutor(const VirtualRobot::RobotPtr& robot, const Params& params) : robot(robot)
        {
        }

        ~DummyExecutor() override
        {
        }

        void
        move(const core::Twist& twist) override
        {
            this->twist = twist;
            //const auto now = std::chrono::time_point_cast<std::chrono::microseconds>(std::chrono::steady_clock::now());

            //const float dt = now - lastUpdated;

            //lastUpdated = now;

            const core::Pose diff; // TODO

            robot->setGlobalPose(robot->getGlobalPose() * diff.matrix());
        }

    private:
        VirtualRobot::RobotPtr robot;

        core::Twist twist;

        std::chrono::microseconds lastUpdated;
    };

} // namespace armarx::navigation::server
